#include "stdafx.h"
#include <string.h>
#include "SECReader.h"
#include "BaseCommunication.h"

#define base CEC30Reader

CSECReader::CSECReader(CReader *Owner,CBaseCommunication *Communicator)
			  :base(Owner,Communicator)
{
}

CSECReader::~CSECReader(void)
{
}


uint16_t CSECReader::HostToReaderShort(uint16_t Value)
{
   return InversByteOrderShort(htons(Value));
}

uint32_t CSECReader::HostToReaderLong(uint32_t Value)
{
   return InversByteOrderLong(htonl(Value));
}

void CSECReader::SetHWString(char *String)
{
   strcpy(String,"SEC_");
}

void CSECReader::GetProductString(uint8_t *Product)
{
	memcpy(Product,"CJSEC",5);
}


CJ_RESULT CSECReader::CtSetContrast(EContrast eContrast,uint32_t *Result)
{
	CJ_RESULT Res;
	switch(eContrast)
	{
	case ContrastVeryLow:
		Res=_CtSetContrast(0,Result);
		break;
	case ContrastLow:
		Res=_CtSetContrast(70,Result);
		break;
	case ContrastMedium:
		Res=_CtSetContrast(120,Result);
		break;
	case ContrastHigh:
		Res=_CtSetContrast(160,Result);
		break;
	case ContrastVeryHigh:
		Res=_CtSetContrast(255,Result);
		break;
	default:
		Res=CJ_ERR_WRONG_PARAMETER;
	}
	return Res;
}

